// File autogenerated

#if !defined(FILETRANSFER1INTERFACE_H_INCLUDED)
#define FILETRANSFER1INTERFACE_H_INCLUDED

// TQt D-Bus includes
#include <tqdbuserror.h>
#include <tqdbusobject.h>

// forward declarations
class TQDomElement;
class TQString;
class TQT_DBusDataList;
class TQT_DBusError;
class TQT_DBusObjectPath;
class TQT_DBusVariant;
template <typename K, typename V> class TQMap;

namespace org
{
namespace bluez
{
namespace obex
{

class FileTransfer1Interface : public TQT_DBusObjectBase
{
public:
    virtual ~FileTransfer1Interface() {}

    static void buildIntrospectionData(TQDomElement& interfaceElement);

    static const TQCString interface() { return TQCString("org.bluez.obex.FileTransfer1"); }

protected:
    virtual bool ChangeFolder(const TQString& folder, TQT_DBusError& error) = 0;

    virtual bool CreateFolder(const TQString& folder, TQT_DBusError& error) = 0;

    virtual bool ListFolder(TQT_DBusDataList& folderinfo, TQT_DBusError& error) = 0;

    virtual bool GetFile(const TQString& targetfile, const TQString& sourcefile, TQT_DBusObjectPath& transfer, TQMap< TQString, TQT_DBusVariant >& properties, TQT_DBusError& error) = 0;

    virtual bool PutFile(const TQString& sourcefile, const TQString& targetfile, TQT_DBusObjectPath& transfer, TQMap< TQString, TQT_DBusVariant >& properties, TQT_DBusError& error) = 0;

    virtual bool CopyFile(const TQString& sourcefile, const TQString& targetfile, TQT_DBusError& error) = 0;

    virtual bool MoveFile(const TQString& sourcefile, const TQString& targetfile, TQT_DBusError& error) = 0;

    virtual bool Delete(const TQString& file, TQT_DBusError& error) = 0;

protected: // implement sending replies
    virtual void handleMethodReply(const TQT_DBusMessage& reply) = 0;

protected: // usually no need to reimplement
    virtual bool handleMethodCall(const TQT_DBusMessage& message);

    TQT_DBusMessage callChangeFolder(const TQT_DBusMessage& message);

    TQT_DBusMessage callCreateFolder(const TQT_DBusMessage& message);

    TQT_DBusMessage callListFolder(const TQT_DBusMessage& message);

    TQT_DBusMessage callGetFile(const TQT_DBusMessage& message);

    TQT_DBusMessage callPutFile(const TQT_DBusMessage& message);

    TQT_DBusMessage callCopyFile(const TQT_DBusMessage& message);

    TQT_DBusMessage callMoveFile(const TQT_DBusMessage& message);

    TQT_DBusMessage callDelete(const TQT_DBusMessage& message);

}; // class FileTransfer1Interface

}; // namespace obex

}; // namespace bluez

}; // namespace org

#endif //FILETRANSFER1INTERFACE_H_INCLUDED

// End of File

