// File autogenerated

#if !defined(OBJECTMANAGERPROXY_H_INCLUDED)
#define OBJECTMANAGERPROXY_H_INCLUDED

// TQt includes
#include <tqobject.h>

// TQt D-Bus includes
#include <tqdbuserror.h>

// forward declarations
class TQString;
class TQStringList;
class TQT_DBusConnection;
class TQT_DBusError;
class TQT_DBusMessage;
class TQT_DBusObjectPath;
class TQT_DBusProxy;
template <typename K> class TQT_DBusDataMap;

namespace org
{
namespace freedesktop
{
namespace DBus
{

class ObjectManagerProxy : public TQObject
{
    TQ_OBJECT
    
public:
    ObjectManagerProxy(const TQString& service, const TQString& path, TQObject* parent = 0, const char* name = 0);

    virtual ~ObjectManagerProxy();

    void setConnection(const TQT_DBusConnection& connection);

signals:
    void InterfacesAdded(const TQT_DBusObjectPath& object, const TQT_DBusDataMap< TQString >& interfaces);

    void InterfacesRemoved(const TQT_DBusObjectPath& object, const TQStringList& interfaces);


public:
    virtual bool GetManagedObjects(TQT_DBusDataMap< TQT_DBusObjectPath >& objects, TQT_DBusError& error);

protected slots: // usually no need to reimplement
    virtual void slotHandleDBusSignal(const TQT_DBusMessage& message);

protected:
    TQT_DBusProxy* m_baseProxy;

private: // Hiding copy constructor and assignment operator
    ObjectManagerProxy(const ObjectManagerProxy&);
    ObjectManagerProxy& operator=(const ObjectManagerProxy&);
}; // class ObjectManagerProxy

}; // namespace DBus

}; // namespace freedesktop

}; // namespace org

#endif //OBJECTMANAGERPROXY_H_INCLUDED

// End of File

